<?php declare(strict_types=1);


namespace Pinpoint\DropShipping\Api;

use Magento\Framework\Api\SearchCriteriaInterface;


interface DropShipItemRepositoryInterface
{

    /**
     * Save DropShipItem
     * @param \Pinpoint\DropShipping\Api\Data\DropShipItemInterface $dropShipItem
     * @return \Pinpoint\DropShipping\Api\Data\DropShipItemInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \Pinpoint\DropShipping\Api\Data\DropShipItemInterface $dropShipItem
    );

    /**
     * Retrieve DropShipItem
     * @param string $dropshipitemId
     * @return \Pinpoint\DropShipping\Api\Data\DropShipItemInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($dropshipitemId);

    /**
     * Retrieve DropShipItem matching the specified criteria.
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Pinpoint\DropShipping\Api\Data\DropShipItemSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete DropShipItem
     * @param \Pinpoint\DropShipping\Api\Data\DropShipItemInterface $dropShipItem
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \Pinpoint\DropShipping\Api\Data\DropShipItemInterface $dropShipItem
    );

    /**
     * Delete DropShipItem by ID
     * @param string $dropshipitemId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($dropshipitemId);
}

